;
; Torre di Hanoi - (c) 1989 by Alessandro Scotti
;
.MODEL TINY
.CODE

MAX        equ 8

org 100h
Entrata: jmp Inizio

Msg_Mossa  db  'Da '
Offset_Da  db  ?
           db  ' a '
Offset_A   db  ?
           db  13,10,36
Piolo1     db 'A'      ; Nomi dei pioli
Piolo2     db 'B'
Piolo3     db 'C'
Msg_Errore db 'Uso: HANOI Numero_dischi ( da 1 a 8 )',13,10,36

Inizio:
         mov  si,80h                   ; Offset CmdTail nel PSP
         cld                           ;
         lodsb                         ;
         or   al,al                    ;
         jz   Errore                   ; Nessun parametro
         mov  cl,al                    ;
         xor  ch,ch                    ;
         inc  cx                       ;
Spazi:   lodsb                         ; Salta gli spazi iniziali
         cmp  al,' '                   ;
         loope Spazi                   ;
         cmp  cx,1                     ; OK se rimane un solo carattere
         jne  Errore                   ;
         sub  al,'0'                   ;
         cmp  al,1                     ;
         jb   Errore                   ;
         cmp  al,MAX                   ;
         ja   Errore                   ;
         mov  bl,al                    ; BL = Numero di dischi
         call Hanoi                    ;
         int  20h                      ; Fine programma
Errore:  mov  dx,offset Msg_Errore     ;
         mov  ah,09h                   ;
         int  21h                      ; Stampa il messaggio...
         int  20h                      ; ... e ritorna al DOS

; Muove un singolo disco dal piolo AH al piolo AL
;
Muovi PROC NEAR                        ;
         push ax                       ; Salva le variabili
         push bx                       ;
         mov  [Offset_Da],ah           ;
         mov  [Offset_A],al            ;
         mov  dx,offset Msg_Mossa      ;
         mov  ah,09h                   ;
         int  21h                      ; Stampa la mossa
         pop  bx                       ; Recupera le variabili...
         pop  ax                       ;
         ret                           ; ... e ritorna
Muovi ENDP                             ;

; Muove BL dischi da AH ad AL utilizzando BH
;
Sposta PROC NEAR                       ;
         cmp  bl,1                     ;
         ja   Sposta_1                 ;
         call Muovi                    ; Un solo disco: muove...
         ret                           ; ... e ritorna
;***     ^ E' comunque preferibile avere un solo punto d'uscita
Sposta_1:                              ;
         dec  bl                       ; Decrementa il numero dischi
         push ax                       ; Salva le variabili
         push bx                       ;
;***     La procedura e' ricorsiva!
         mov  cl,al                    ; Scambia AL e BH
         mov  al,bh                    ;
         mov  bh,cl                    ;
;***     Il tutto equivale a: xchg al,bh
         call Sposta                   ; Sposta i primi N-1 dischi
         pop  bx                       ; Recupera le variabili
         pop  ax                       ;
         call Muovi                    ; Sposta il disco rimasto
         mov  cl,ah                    ; Scambia AH e BH
         mov  ah,bh                    ;
         mov  bh,cl                    ;
         call Sposta                   ; Rimette a posto gli N-1 dischi spostati
         ret                           ;
Sposta ENDP                            ;

; BL = numero di dischi
;
Hanoi PROC NEAR                        ;
         mov  ah,[Piolo1]              ; Legge i nomi dei pioli
         mov  al,[Piolo2]              ;
         mov  bh,[Piolo3]              ;
         call Sposta                   ; Calcolo delle mosse
         ret                           ;
Hanoi ENDP                             ;

END Entrata
